﻿Public Class Form1
    Public CHIP_SIZE As Integer = 16
    Public chipImgCnt As Integer = 2
    Public sImgPath As String = "C:\MEGA\pict\for game\AC01\stage\chip0\"
    Public imgTemp As Image() ' = New Image() {Image.FromFile(sImgPath & "000.png")}
    Public fMapScale As Single = 1
    Public iMapDatX As Integer = 16
    Public iMapDatY As Integer = 16
    Public bExistImg(256) As Boolean

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim Ret As DialogResult

        Try

            Using Dialog As New FolderBrowserDialog()

                With Dialog
                    .Description = "フォルダを選択してください。"
                    ' .RootFolder = System.IO.Directory.GetCurrentDirectory()
                End With

                Ret = Dialog.ShowDialog()
                If Ret = DialogResult.OK Then
                    sImgPath = Dialog.SelectedPath + "\"
                    TextBox1.Text = TextBox1.Text + sImgPath + vbcrlf
                End If

            End Using

        Catch ex As Exception

            TextBox1.Text = TextBox1.Text + Err.Description + vbcrlf

        End Try



        iMapDatX = Integer.Parse(TextBox3.Text)
        iMapDatY = iMapDatX

        Dim i As Integer
        Dim texfile As String
        chipImgCnt = 0
        For i = 0 To 255
            bExistImg(i) = False
            texfile = sImgPath + i.ToString("D3") + ".png"
            'MsgBox(texfile)
            If System.IO.File.Exists(texfile) Then
                chipImgCnt = chipImgCnt + 1
                bExistImg(i) = True
            End If
        Next i
        TextBox1.Text = TextBox1.Text + ("見つかったファイル数：" & chipImgCnt & vbCrLf)

        ReDim imgTemp(256)
        For i = 0 To 255
            If bExistImg(i) Then
                texfile = sImgPath + i.ToString("D3") + ".png"
                imgTemp(i) = Image.FromFile(texfile)
            End If
        Next i

        '----------------
        CHIP_SIZE = imgTemp(0).Width
        PictureBox1.Width = CHIP_SIZE * iMapDatX
        PictureBox1.Height = CHIP_SIZE * iMapDatY

        PictureBox1.Invalidate()

        '永続的なGraphicsオブジェクトを作成
        PictureBox1.Image = New Bitmap(PictureBox1.Width, PictureBox1.Height) '(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)


    End Sub

    Private Sub PictureBox1_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1.Paint

        'CHIP_SIZE = Integer.Parse(TextBox2.Text)
        iMapDatX = Integer.Parse(TextBox3.Text)
        iMapDatY = iMapDatX

        Dim width As Integer
        Dim height As Integer
        width = CHIP_SIZE * fMapScale
        height = CHIP_SIZE * fMapScale


        Dim g As Graphics
        g = Graphics.FromImage(PictureBox1.Image)

        '下マップ
        For y = 0 To iMapDatY - 1 'picMapWindow.Height / height 'iMapDatY - 1
            For x = 0 To iMapDatX - 1 'picMapWindow.Width / width 'width - 1
                '切り取る部分の範囲を決定する。
                Dim srcRect As New Rectangle(0, 0, CHIP_SIZE, CHIP_SIZE)
                '描画する部分の範囲を決定する。
                Dim desRect As New Rectangle(x * CHIP_SIZE, y * CHIP_SIZE, CHIP_SIZE, CHIP_SIZE)
                '画像の一部を描画する

                Dim idx = x * iMapDatY + y 'y * iMapDatX + x
                If bExistImg(idx) Then
                    g.DrawImage(imgTemp(idx), desRect, srcRect, GraphicsUnit.Pixel)
                End If
            Next x
        Next y
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        '保存
        PictureBox1.Image.Save(sImgPath & "★自動整列.png", Imaging.ImageFormat.Png)
        TextBox1.Text = TextBox1.Text + ("ファイル出力完了　" & sImgPath & "★自動整列.png" & vbCrLf)
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim i As Integer
        For i = 0 To 255
            bExistImg(i) = False
        Next i
        '永続的なGraphicsオブジェクトを作成
        PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)



        'Dim sCurrentFile As String
        'sCurrentFile = "config.ini"
        'Dim sr As New System.IO.StreamReader(sCurrentFile, System.Text.Encoding.GetEncoding("UTF-8"))
        'Dim s As String
        '１行読み込む
        's = sr.ReadLine()
        'sImgPath = s

        'imgTemp = New Image() {Image.FromFile(sImgPath & "000.png")}

    End Sub

End Class
